// eforia web manager Import Modul
// Importiert Dateien aus Verzeichnis in die Datenbanken
// Horst Klier 15.11.2006

Var cImportPath : String 
Var cBasePath : String 

Uses util
Uses db_maintain
Uses strings

Procedure AddPath(c:String):String
  c:=cBasePath+'/'+c
  Return c
EndProc

Procedure GetLinkFiles(cName:String;db:Integer):Integer
  // Geht fr db=cms_files und cms_gfx
  Var aSplits:String[]
  Var nSplits,n,n2,nLastLfd,nRec : Integer
  Var cBranch : String
  nSplits:=split4(aSplits,cName,'/',0,0,0)
  nSplits-- // filename brauchen wir nicht
  nLastLfd:=0
  n:=0
  While n<nSplits Do
    // Teilbranch ermitteln also z.b. ewm/presse/flash
    cBranch:=''
    n2:=0
    While n2<=n Do
      cBranch:=cBranch+aSplits[n2]+'/'
      n2++
    End
    cBranch:=cBranch[1,Length(cBranch)-1]
    ////
    nRec:=FindRec(db,cBranch,IndNo_ID,1)
    While nRec>0 do
      ReadRec(db,nRec)
      If Lower(GetField(db,'Name'))#Lower(cBranch) then
        nRec:=0
      Else
        If GetRField(db,'IsFile')=0 then
          nLastLfd:=AutoRecNo(db)
          nRec:=-1  // Kennung fr Branch gefunden
        Else
          nRec:=NextRec(db)
        End
      End
    End
    If nRec#-1 then  // Muss angelegt werden
      ReadRec(db,0)
      SetField(db,'Name',cBranch)
      SetRField(db,'IsFile',0)
      If Lower(DBName(db))[1,9]='cms_files' then
        SetRField(db,'Link_Files',nLastLfd)
      Else
        SetRField(db,'Link_Gfx',nLastLfd)
      End
      WriteRec(db,FileSize(db)+1)
      nLastLfd:=AutoRecNo(db)
    End
    n++
  End
  Return nLastLfd
EndProc


Procedure CopyToFileFolder(cFile:String):String
  // kopiert Datei nach file oder gfx
  // wenn Endung jpg/gif/png/swf dann gfx, sonst files
  // Rckgabe ist der Name, unter dem die Datei abgelegt wurde
  Var cFilename,cSecure,cExt,cDir : String
  Var n : Integer
  cDir:='../files/'
  cFilename:=reverse(cFile)
  cExt:=cFilename[1,Pos('.',cFilename)]
  cExt:=reverse(cExt)
  cFilename:=cFilename[1,Pos('/',cFilename)-1]
  cFilename:=cFilename[Pos('.',cFilename)+1,255]
  cFilename:=reverse(cFilename)
  If cExt in ['.jpg','.jpeg','.gif','.png','.swf'] then
    cDir:='../gfx/'
  End
  cFilename:=cDir+cSecure+cFilename+cExt
  If CopyFile(cFile,cFilename)#0 then
    CGIWriteLn(' problem: '+cFile+' -> '+cFilename)
  End
  Return cFilename
EndProc

Procedure CheckForFileName(cFile:String;db:Integer):Integer
  Var nRet,nRec : Integer
  nRet:=0
  Access(db,-1)
  nRec:=FirstRec(db)
  While nRec>0
    ReadRec(db,nRec)
    If Lower(GetField(db,'File_Name'))=Lower(cFile) then
      nRet:=1
      nRec:=0
    Else
      nRec:=NextRec(db)
    End
  End
  Return nRet
EndProc

Procedure AddFile(cFile:String;dbF,dbG:Integer)
  Var db : Integer
  CGIWrite('  adding '+cFile)
  // JPG nach GFX, alles andere nach files
  If reverse(reverse(Lower(cFile))[1,Pos('.',reverse(Lower(cFile)))]) in ['.jpg','.jpeg','.gif','.png','.swf'] then
    db:=dbG
  Else
    db:=dbF
  End
  If CheckForFileName(cFile,db)=1 then
    CGIWriteLn(' already here')
  Else
    Var c,cName,cSize,cHint,cDate,cTime : String
    Var nLinkFiles,nSecure : Integer
      nSecure:=0
      cName:=cFile[Length(cImportPath+'/')+1,255]
      cName:=AddPath(cName)
      c:=DirInfo(cFile)
      cDate:=c[84,10]
      cTime:=c[96,5]
      cSize:=c[71,11]
      cHint:=cFile[Length(cImportPath+'/')+1,255]
      CGIWriteLn(' new')
      nLinkFiles:=GetLinkFiles(cName,db)
      ReadRec(db,0)
      If db=dbF then
        SetRField(db,'Link_Files',nLinkFiles)
      Else
        SetRField(db,'Link_Gfx',nLinkFiles)
      End
      SetField(db,'Language','de')
      SetField(db,'Name',cName)
      SetField(db,'File_Name',CopyToFileFolder(cFile))
      If db=dbF then
        SetField(db,'Dateidatum',cDate)
        SetField(db,'Dateizeit',cTime)
        SetField(db,'Groesse',cSize)
        SetField(db,'Beschreibung',cName)
        SetField(db,'Hinweise',cHint)
      End
      SetRField(db,'IsFile',1)
      WriteRec(db,FileSize(db)+1)
  End
EndProc


Procedure ScanDir(cDir:String;dbF,dbG:Integer)
  Var c,cFile : String
  Var nDirs : Integer
  Var acDirs : STRING[99999]
  cDir:=Exchange(cDir,'\','/')
  If RightStr(cDir,1)#'/' Then
    cDir:=cDir+'/'
  End
    CGIWriteLn('scanning '+cDir+'...')
    c:=FirstDir(cDir,'')
    nDirs:=0
    While c#'' Do
      cFile:=LTrim(RTrim(c[1,63]))
      // Dateiname zu lang? Spezial:
      If Length(cFile)>63 then
        c:=''
      End
      If Pos('D',Upper(c[64,6]))=0
        AddFile(cDir+cFile,dbF,dbG)
      Else
        If cFile in ['.','..'] then
          // Ignorieren
        Else
          acDirs[nDirs]:=cFile
          nDirs++
        End
      End
      c:=NextDir
    End
    While nDirs>0 Do
      nDirs--
      ScanDir(cDir+acDirs[nDirs],dbF,dbG)
    End
EndProc


Procedure Main
  CGICloseBuffer
  CGIWriteLn('Import Files to ewm Database')
  CGIWriteLn('V 1.3 Horst Klier 15.11.2006')
  CGIWriteLn('')
 
  If ParamStr(3)='' then
    CGIWriteLn('usage:')
    CGIWriteLn('  tdbengine hkimport.prg importpath treepath')
    CGIWriteLn('  importpath = here the files will be searched')
    CGIWriteLn('  treepath   = in this path the files will be stored in tree')
    CGIWriteLn('')
    CGIWriteLn('  example:')
    CGIWriteLn('  tdbengine hkimport.prg import/photo family/photo/holiday')
    CGIWriteLn('  files from import/photo/* will be imported to family/photo/holiday/*')
    Halt
  End 

  cImportPath:=ParamStr(2)
  cBasePath:=ParamStr(3)
  
  CGIWriteLn(' - import from '+cImportPath)
  CGIWriteLn(' - import to   '+cBasePath)
  Var dbF,dbG,nRec : Integer
  dbF:=GetTable('cms_files')
  dbG:=GetTable('cms_gfx')

  //
  ScanDir(cImportPath,dbF,dbG)
  CloseDB(dbG)
  CloseDB(dbF)
  CGIWriteLn('Regeneriere Volltext')
  CGIWriteLn(Db_Maintain_GenerateFulltext('cms_files','../sysdef/cms_files.def','../sysbase/cms_files_vt'))
  CGIWriteLn(Db_Maintain_GenerateFulltext('cms_gfx','../sysdef/cms_gfx.def','../sysbase/cms_gfx_vt'))

EndProc


